#!/usr/local/bin/perl4.017

# httpget --- get a file specified by URL via HTTP
#	1995/1/23 hideki@yk.rim.or.jp

$http_version = '1.0';
$proxy_server = 'proxy.foo.bar.com';
#$proxy_port = 80;
$proxy_port = 8080;
$no_proxy = '^http:.*\.bar\.com';
$timeout_sec = 180;

($prog = $0) =~ s/.*\///;
require 'getopts.pl';

&Getopts('rv');

&usage if ($#ARGV < 0 || $#ARGV > 1);
$url = $ARGV[0];
if ($#ARGV < 1) {
  ($dest = $url) =~ s/\S+:\/\/[^\/]*//;
  $dest =~ s/.*\///;
  $dest = 'default.html' if ($dest eq '');
} else {
  $dest = $ARGV[1];
}

require 'chat2.pl';
&http_get($url, $dest);

sub usage {
  die "Usage: $prog [-rv] URL [dest]\n";
}

sub http_get {
  local($url, $dest) = @_;
  local($server, $port, $request, $retcode, $remotesize, $localsize,
        $rmask, $nfound);

  if ($url =~ /$no_proxy/) {
    $url =~ /^http:\/\/([^\/:]+)(:(\d+))?(\/\S*)?/
      || die "$prog: cannot transfer directly: $url\n";
    $server = $1;
    $port = $3 ? $3 : 80;
    $url = $4 ? $4 : '/';
  } else {
    $server = $proxy_server;
    $port = $proxy_port;
  }
  ($http = &chat'open_port($server, $port))
    || die "$prog: chat'open_port($server, $port): $!\n";
  $request = "GET $url HTTP/$http_version";
  &chat'print($http, "$request\r\n")
    || die "$prog: chat'print(\"$request\"): $!\n";
  if ($opt_r) {
    $request = "Pragma: no-cache";
    &chat'print($http, "$request\r\n")
      || die "$prog: chat'print(\"$request\"): $!\n";
  }
  &chat'print($http, "\r\n")
    || die "$prog: chat'print(\"\\n\"): $!\n";
  *S = *chat'S;
  $remotesize = -1;
  while (($_ = <S>) && $_ ne "\r\n" && $_ ne "\n") {
    if (/^HTTP\/$http_version (\d+)/i) {
      $retcode = $1;
    } elsif (/^Content-Length: (\d+)/i) {
      $remotesize = $1;
    }
    print STDERR $_ if ($opt_v);
  }
  die "$prog: return code was $retcode\n" unless ($retcode == 200);
  if ($dest) {
    open(DEST, ">$dest") || die "$prog: can't create $dest";
    $rmask = '';
    vec($rmask, fileno(S), 1) = 1;
    $localsize = 0;
    do {
      ($nfound, $rmask) = select($rmask, undef, undef, $timeout_sec);
      die "$prog: timed out at $url\n" unless ($nfound);
      $_ = <S>;
      print DEST $_ if ($_);
      $localsize += length($_);
      if ($opt_v) {
        print STDERR ($remotesize == -1) ? "$localsize\r"
                                         : "$localsize/$remotesize\r";
      }
    } while ($nfound && $_);
    close(DEST);
    if ($localsize != (stat($dest))[7]) {
      unlink($dest);
      die "$prog: file $dest shorter than transferred $localsize bytes\n";
    }
    if ($remotesize != -1 && $remotesize != $localsize) {
      unlink($dest);
      die "$prog: only $localsize bytes of $remotesize bytes transferred\n";
    }
  }
  &chat'close($http);
}
